Subject: Re: linux-next: build failure after merge of the watchdog tree

From: Guenter Roeck <[email-masked]>
Date: Thu, 25 Sep 2014 23:12:01 -0700

On 09/25/2014 10:56 PM, Pramod Gurav wrote:
> On Friday 26 September 2014 11:10 AM, Stephen Rothwell wrote:
>> Hi Wim,
>>
>> After merging the watchdog tree, today's linux-next build (arm
>> multi_v7_defconfig) failed like this:
>>
>>
>> drivers/watchdog/meson_wdt.c: In function 'meson_wdt_probe':
>> drivers/watchdog/meson_wdt.c:178:2: error: implicit declaration of function 'register_restart_handler' [-Werror=implicit-function-declaration]
>>    err = register_restart_handler(&meson_wdt->restart_handler);
>>    ^
>> drivers/watchdog/meson_wdt.c: In function 'meson_wdt_remove':
>> drivers/watchdog/meson_wdt.c:193:2: error: implicit declaration of function 'unregister_restart_handler' [-Werror=implicit-function-declaration]
>>    unregister_restart_handler(&meson_wdt->restart_handler);
>>    ^
>>
> This is because Guenter Roeck's restart_notifier mechanism [1] has not
> yet made it to linux-next.
>
No, that isn't it; it is there, coming from Andrew Morton's tree.
I think the problem is that the functions are not in Wim's tree,
and neither is ARCH_MESON. For this reason, the driver does not
build in Wim's tree, nor in my tree, which in turn explains why
we don't see the error. Maybe Stephen merges Andrew's tree after the
watchdog tree, and builds the watchdog code immediately after pulling it.
If the MESON code is already merged at that time we would see that error.

Question is how to handle that kind of situation. An idea, anyone ?

Someone suggested that I should create an immutable tree with the
restart handler patchset, which everyone using the restart handlers
could merge. Is that an option ? I could technically do that,
but I would want to pick the patches from Andrew's tree to retain
his sign-off. Andrew, any thoughts/comments ?

Thanks,
Guenter